Subject: [OT - MPC5200B] strange framing, break problems with uart

From: Albrecht Dreß <[email-masked]>
Date: Thu, 03 Feb 2011 19:34:32 +0100

Hi all,

sorry for a slightly off-topic question, but I hope someone here on the list may be able to help me...

I have a strange problem with the psc uart of the mpc5200b, running 2.6.32.26 (still), with my baud rate divisor selection patch [1].

The uart runs at 115.2 kBaud with rtc/cts handshake to send bigger chunks of data to the '5200.  I noticed "missing" data in the input stream, and inspected the uart status using the TIOCGICOUNT ioctl which tells me that a bunch of framing and break errors occurred.  I "tapped" the RxD line and connected it via a level shifter to a standard 16450-style uart in a (much faster) Linux PC, and *that* one receives the *complete* stream *without any* break or framing errors!

I also looked at the waveforms with an oscilloscope, and they look pretty fine.  The port configuration should also be ok, re-checked with a bdi3000 jtag debugger - it's PSC3, set to '1100', with PSC3_0 .. PSC3_3 being used here.

This leads me to the assumption that either the hardware handshake or the Linux driver or both are broken...  any insight would be highly appreciated!

Cheers,
Albrecht.

[1] <http://patchwork.ozlabs.org/patch/48884/>; included in 2.6.37